/* 
	UTILS.C

	Utility procedures used throughout FORM FILL-R
*/

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <ctype.h>
#include <dos.h>
#include "keys.h"
#include "screen.h"

/* Prototypes */

void center (int line, char *text);
void fkeydefn (int line, int col, int fkey, char *text);
void box_text(int line, char *title);
int confirm();

/*

	CENTER

	Centers a line of text on the screen
*/
void center (int line, char *text)
{
   char buf[80];
   register int i;
   register char *p;

	p = text;
	while (isspace(*p)) p++;
	strcpy(buf,p);
	i = strlen(buf);
	p = buf + i;
	while (i-- > 0 && isspace(*--p)) *p = '\0';

	setcur(line,40-(strlen(buf)/2));
	wstr(buf);
}

/*
	fkeydefn

	Displays a function key definition on the screen

*/
void fkeydefn (int line, int col, int fkey, char *text)
{  char buf[10];
	setcur(line,col);
	if (fkey <= 9)
	  wchar(' ');
	sprintf(buf,"\1F%d\2 ",fkey);
	wstr(buf);
	wstr(text);
}

void box_text(int line, char *title)
{  register int i;

	i = strlen(title)/2;
	box(line,38-i,line+2,42+i,1);
	center(line+1,title);
}

/* confirm -- Return true/false to Yes/No question.
	 Key:	Action:
	  Y	Return True
	N,ESC,
	 F10	Return False
*/	 	

int confirm()
{
	while (1)
	  switch(gtkey())
	    { case 'Y':
	      case 'y':
		return(1);
	      case 'N':
	      case 'n':
	      case F10:
	      case ESC:
		return(0);
	    }
}

